%define	__s		-s
%define	__soversion	3.1
%define	_libdb_a	libdb-%{__soversion}.a
%define nssdb_ver	2.1.92

Summary: The Berkeley DB database library for C.
Name: db3
Version: 3.1.14
Release: 6
Source: http://www.sleepycat.com/update/%{version}/db-%{version}.tar.gz
Source1: http://members1.chello.nl/~m.m.kettenis/nss_db-%{nssdb_ver}.tar.gz
Patch0: http://www.sleepycat.com/update/%{version}/patch.3.0.55.1
Patch1: db-3.0.55-linux.patch
Patch2: db-3.0.55-jbj.patch
Patch10: nss_db-%{nssdb_ver}-compat.patch
URL: http://www.sleepycat.com
Copyright: GPL
Group: System Environment/Libraries
PreReq: /sbin/ldconfig

# XXX written as a file prereq in order to build with glibc-2.1.3
%ifos linux
BuildPrereq: /usr/lib/libdb1.a
%ifnarch ia64
Conflicts: glibc < 2.1.92-6
%endif
%endif

BuildRoot: %{_tmppath}/%{name}-root
Prefix: %{_prefix}

%description
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB is used by many applications, including Python and Perl, so this
should be installed on all systems.

%package utils
Summary: Command line tools for managing Berkeley DB databases.
Group: Applications/Databases
Prefix: %{_prefix}

%description utils
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains command line tools for managing Berkeley DB databases.

%package devel
Summary: Development libraries/header files for the Berkeley DB library.
Group: System Environment/Libraries
Prefix: %{_prefix}

%description devel
The Berkeley Database (Berkeley DB) is a programmatic toolkit that provides
embedded database support for both traditional and client/server applications.
Berkeley DB includes B+tree, Extended Linear Hashing, Fixed and Variable-length
record access methods, transactions, locking, logging, shared memory caching
and database recovery. DB supports C, C++, Java and Perl APIs.

This package contains the header files, libraries, and documentation for
building programs which use Berkeley DB.

%prep
%setup -q -n db-%{version}
#%patch0 -p0
#%patch1 -p1 -b .linux

# XXX not applied
#%patch1 -p1 -b .jbj

# nss_db and compat nss_db, move me into nss_db standalone package
# soon
cd ..
rm -rf nss_db-%{nssdb_ver} nss_db-compat-%{nssdb_ver}
tar xzf %{SOURCE1}
mkdir nss_db-compat-%{nssdb_ver}
cd nss_db-compat-%{nssdb_ver}
tar xzf %{SOURCE1}; mv -f nss_db-%{nssdb_ver}/* .
%patch10 -p1 -b .compat
rm -rf nss_db-%{nssdb_ver}

%build

cd build_unix

# XXX --enable-tcl can't add without picking up dependency on libtcl.so
# XXX --enable-posixmutexes (missing pthread_{cond,mutex}attr_setpshared)
# XXX --enable-cxx (barfs on clone proto in /usr/include/bits/sched.h)
# XXX --enable-debug_{r,w}op should be disabled for production.
CFLAGS="$RPM_OPT_FLAGS" ../dist/configure --prefix=%{_prefix} --enable-debug --enable-compat185 --enable-diagnostic --enable-dump185 --enable-shared --enable-static --enable-rpc --enable-tcl # --enable-test --enable-debug --enable-debug_rop --enable-debug_wop # --enable-posixmutexes

make libdb=%{_libdb_a} %{_libdb_a}

# Static link with old db-185 libraries.
/bin/sh ./libtool --mode=compile cc -c -O2 -g -g -I/usr/include/db1 -I../dist/../include -D_REENTRANT  ../dist/../db_dump185/db_dump185.c
cc %{__s} -static -o db_dump185 db_dump185.lo -L%{_libdir} -ldb1

# Compile rest normally.
make libdb=%{_libdb_a} TCFLAGS='-I$(builddir) -I/usr/include' LDFLAGS="%{__s}"

cd ..

# nss_db
cd ../nss_db-%{nssdb_ver}
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{_prefix}
make
cd ../nss_db-compat-%{nssdb_ver}
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{_prefix}
make

%install
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}%{_includedir}
mkdir -p ${RPM_BUILD_ROOT}%{_prefix}/lib

cd build_unix

# XXX install_tcl
# XXX install_static_cxx
# XXX install_dynamic_cxx
# XXX install_java
# XXX install_docs (handled by %docs)
make libdb=%{_libdb_a} LDFLAGS="%{__s}" prefix=${RPM_BUILD_ROOT}%{_prefix} install_include install_dynamic install_static install_tcl install_utilities

# XXX annoying
set -x
( cd ${RPM_BUILD_ROOT}

%ifos linux
  mkdir -p ./%{_lib}
  mv .%{_prefix}/lib/libdb[-.]*so* ./%{_lib}
  if [ "%{_libdir}" != "%{_prefix}/lib" ]; then
    mkdir -p .%{_libdir}
    mv .%{_prefix}/lib/libdb* .%{_libdir}
  fi
%endif

  mkdir -p .%{_includedir}/db3
  mv .%{_prefix}/include/*.h .%{_includedir}/db3
  ln -sf db3/db.h .%{_includedir}/db.h
#  for F in .%{_prefix}/bin/db_* ; do
#    mv $F `echo $F | sed -e 's,/db_,/db3_,'`
#  done
)
set +x

cd ..

# nss_db
cd ../nss_db-%{nssdb_ver}
mkdir -p ${RPM_BUILD_ROOT}/%{_lib} ${RPM_BUILD_ROOT}/var/db ${RPM_BUILD_ROOT}/%{_prefix}/bin
cp -a .libs/libnss_db.so.[0-9]* ${RPM_BUILD_ROOT}/%{_lib}/
cp -a db-Makefile ${RPM_BUILD_ROOT}/var/db/Makefile
install -m 755 makedb ${RPM_BUILD_ROOT}/%{_prefix}/bin
cd ../nss_db-compat-%{nssdb_ver}
cp -a .libs/libnss_db.so.[0-9]* ${RPM_BUILD_ROOT}/%{_lib}/

# XXX libdb-3.1.so is in /lib teach libtool as well
perl -pi -e 's,/usr,,' ${RPM_BUILD_ROOT}%{_libdir}/libdb-%{__soversion}.la

%clean
rm -rf ${RPM_BUILD_ROOT}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc LICENSE README docs/images
%ifos linux
/%{_lib}/libdb-%{__soversion}.so
%else
%{_libdir}/libdb-%{__soversion}.so
%endif

# nss_db stuff, move to separate package ASAP
/%{_lib}/libnss_db*
%{_prefix}/bin/makedb
%dir /var/db
/var/db/Makefile

%files utils
%defattr(-,root,root)
%doc	docs/utility
%{_libdir}/libdb_tcl.so
%{_libdir}/libdb_tcl-%{__soversion}.la
%{_libdir}/libdb_tcl-%{__soversion}.so
%{_bindir}/berkeley_db_svc
%{_bindir}/db*_archive
%{_bindir}/db*_checkpoint
%{_bindir}/db*_deadlock
%{_bindir}/db*_dump
%{_bindir}/db*_dump185
%{_bindir}/db*_load
%{_bindir}/db*_printlog
%{_bindir}/db*_recover
%{_bindir}/db*_stat
%{_bindir}/db*_upgrade
%{_bindir}/db*_verify

%files devel
%defattr(-,root,root)
%doc	docs/api_c docs/api_cxx docs/api_java docs/api_tcl docs/index.html
%doc	docs/ref docs/sleepycat
%doc	examples_c examples_cxx
%{_libdir}/libdb-%{__soversion}.la
%{_libdir}/%{_libdb_a}
%{_includedir}/db3/db.h
%{_includedir}/db3/db_185.h
%{_includedir}/db3/db_cxx.h
%{_includedir}/db.h
%ifos linux
/%{_lib}/libdb.so
%else
%{_libdir}/libdb.so
%endif

%changelog
* Wed Aug 30 2000 Matt Wilson <msw@redhat.com>
- rebuild to cope with glibc locale binary incompatibility, again

* Wed Aug 23 2000 Jeff Johnson <jbj@redhat.com>
- remove redundant strip of libnss_db* that is nuking symbols.
- change location in /usr/lib/libdb-3.1.la to point to /lib (#16776).

* Thu Aug 17 2000 Jeff Johnson <jbj@redhat.com>
- summaries from specspo.
- all of libdb_tcl* (including symlinks) in db3-utils, should be db3->tcl?

* Wed Aug 16 2000 Jakub Jelinek <jakub@redhat.com>
- temporarily build nss_db in this package, should be moved
  into separate nss_db package soon

* Wed Jul 19 2000 Jakub Jelinek <jakub@redhat.com>
- rebuild to cope with glibc locale binary incompatibility

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Sun Jun 11 2000 Jeff Johnson <jbj@redhat.com>
- upgrade to 3.1.14.
- create db3-utils sub-package to hide tcl dependency, enable tcl Yet Again.
- FHS packaging.

* Mon Jun  5 2000 Jeff Johnson <jbj@redhat.com>
- disable tcl Yet Again, base packages cannot depend on libtcl.so.

* Sat Jun  3 2000 Jeff Johnson <jbj@redhat.com>
- enable tcl, rebuild against tcltk 8.3.1 (w/o pthreads).

* Tue May 30 2000 Matt Wilson <msw@redhat.com>
- include /lib/libdb.so in the devel package

* Wed May 10 2000 Jeff Johnson <jbj@redhat.com>
- put in "System Environment/Libraries" per msw instructions.

* Tue May  9 2000 Jeff Johnson <jbj@redhat.com>
- install shared library in /lib, not /usr/lib.
- move API docs to db3-devel.

* Mon May  8 2000 Jeff Johnson <jbj@redhat.com>
- don't rename db_* to db3_*.

* Tue May  2 2000 Jeff Johnson <jbj@redhat.com>
- disable --enable-test --enable-debug_rop --enable-debug_wop.
- disable --enable-posixmutexes --enable-tcl as well, to avoid glibc-2.1.3
  problems.

* Mon Apr 24 2000 Jeff Johnson <jbj@redhat.com>
- add 3.0.55.1 alignment patch.
- add --enable-posixmutexes (linux threads has not pthread_*attr_setpshared).
- add --enable-tcl (needed -lpthreads).

* Sat Apr  1 2000 Jeff Johnson <jbj@redhat.com>
- add --enable-debug_{r,w}op for now.
- add variable to set shm perms.

* Sat Mar 25 2000 Jeff Johnson <jbj@redhat.com>
- update to 3.0.55

* Tue Dec 29 1998 Jeff Johnson <jbj@redhat.com>
- Add --enable-cxx to configure.

* Thu Jun 18 1998 Jeff Johnson <jbj@redhat.com>
- Create.
